''#Include "windows.bi"
'   
type ListNode

	declare constructor()  ' 

	id as UInteger   '  

	valueS as String  '      
	valueI As Integer
	valueD As Double
	ValueL As longint
	ValueB As Byte
	ValueSH As Short
	prev_node as ListNode Ptr  '    

	next_node as ListNode Ptr  '    

End type


'  
type List

	declare constructor() ' 

	declare destructor() ' 

	declare sub Clear() '     

	declare function AddLastS ( as string ) as UInteger '       
	declare function AddLastL ( as LongInt ) as UInteger '       
	Declare function AddLastIn ( as Integer ) as UInteger '       
	Declare function AddLastD ( as Double ) as UInteger '       
	Declare function AddLastB ( as Byte ) as UInteger '       
	Declare function AddLastSH ( as Short ) as UInteger '       
	Declare Sub AddHeadS (As String)
	Declare Sub AddHeadL (As LongInt)
	Declare Sub AddHeadD (As Double)
	Declare Sub AddHeadIn ( As integer)
	Declare Sub AddHeadB ( As Byte)
	Declare Sub AddHeadSH ( As Short)
	Declare function Insert_S (As UInteger,As String) As UInteger
	Declare function Insert_SH (As UInteger,As Short) As UInteger
	Declare function Insert_B (As UInteger,As Byte) As UInteger
	Declare function Insert_In (As UInteger,As Integer) As UInteger
	Declare function Insert_D (As UInteger,As Double) As UInteger
	Declare function Insert_L (As UInteger,As LongInt) As UInteger
	Declare function Move (As UInteger, As UInteger) As UInteger

	declare sub Remove( as uinteger ) '    

	declare function FindByID( as uinteger ) as ListNode Ptr '    
	Declare Function GetCount (As List Ptr) As Integer
	Declare function GURR( ) as ListNode Ptr
	Declare function GURR1( ) as ListNode Ptr
	Declare function PRED( ) as ListNode Ptr
	Declare function First( ) as ListNode Ptr
	Declare function Last( ) as ListNode Ptr
	Gurrent As ListNode Ptr   '  

	'declare sub ShowAll() '    

	first_node as ListNode Ptr '    

	last_node as ListNode Ptr '    

end type

Declare Function SelectElement(ByVal list As List Ptr,ByVal  element As integer) as ListNode Ptr
'  
constructor ListNode()
'   
this.id = 0
this.prev_node = 0
this.next_node = 0

End constructor


'  
constructor List()
'   
this.first_node = 0
this.last_node = 0
End constructor


'  
destructor List()
'    
this.Clear()
end destructor


'    
sub List.Clear()

	dim del_node as ListNode Ptr '    

	dim next_node as ListNode Ptr '    

	del_node = this.first_node '    

	do while del_node '    ,     

		next_node = del_node->next_node '     

		delete del_node '  

		del_node = next_node '    

	Loop

	'  
	this.first_node = 0
	this.last_node = 0

end Sub
'       
function List.Move (idIN As UInteger,idFROM As UInteger) As UInteger
	Dim ELE_from as ListNode Ptr '    
	Dim ELE_in as ListNode Ptr '    
	ELE_from= first_node '    
	ELE_in= first_node '    

	do while ELE_in '    ,     
		if ELE_in->id = idIN Then '    
			Exit Do
		end If
		ELE_in= ELE_in->next_node '    
	Loop
	do while ELE_from '    ,     
		if ELE_from->id = idFROM Then '    
			Exit Do
		end If
		ELE_from= ELE_from->next_node '    
	Loop
	'--------
	If ELE_from=first_node And ELE_in=Last_node Then  
		first_node=first_node->next_node
		first_node->prev_node=0
		ELE_from->prev_node=Last_node
		Last_node->next_node=ELE_from
		ELE_from->next_node=0
		last_node=ELE_from
	ElseIf ELE_from=Last_node And ELE_in=first_node Then 
		last_node=last_node->prev_node
		last_node->next_node=0
		ELE_from->next_node=first_node
		first_node->prev_node=ELE_from
		ELE_from->prev_node=0
		first_node=ELE_from
	ElseIf ELE_from=last_node Then   
		last_node=last_node->prev_node
		ELE_from->prev_node=ELE_in->prev_node
		ELE_in->prev_node->next_node=ELE_from
		ELE_from->next_node=ELE_in
		ELE_in->prev_node=ELE_from
		last_node->next_node=0
	ElseIf ELE_from=first_node Then    
		first_node=first_node->next_node
		ELE_from->next_node=ELE_in->next_node
		ELE_in->next_node->prev_node=ELE_from
		ELE_from->prev_node=ELE_in
		ELE_in->next_node=ELE_from
		first_node->prev_node=0
	ElseIf ELE_in=first_node Then 	
		ELE_from->next_node->prev_node=ELE_from->prev_node
		ELE_from->prev_node->next_node=ELE_from->next_node
		ELE_from->next_node=ELE_in
		ELE_in->prev_node=ELE_from
		ELE_from->prev_node=0
		first_node=ELE_from
	ElseIf ELE_in=Last_node Then 	
		ELE_from->next_node->prev_node=ELE_from->prev_node
		ELE_from->prev_node->next_node=ELE_from->next_node
		ELE_from->prev_node=ELE_in
		ELE_in->next_node=ELE_from
		ELE_from->next_node=0
		Last_node=ELE_from
	Else                         
		If ELE_from=ELE_in Then
			Return 1
		EndIf
		ELE_from->prev_node->next_node=ELE_from->next_node
		ELE_from->next_node->prev_node=ELE_from->prev_node
		If ELE_from<ELE_in Then
			ELE_from->next_node=ELE_in->next_node
			ELE_in->next_node->prev_node=ELE_from
			ELE_in->next_node=ELE_from
			ELE_from->prev_node=ELE_in
		Else
			ELE_in->prev_node->next_node=ELE_from
			ELE_from->prev_node=ELE_in->prev_node
			ELE_from->next_node=ELE_in
			ELE_in->prev_node=ELE_from
		EndIf
	EndIf

	Dim tem As ListNode Ptr
	Dim jj As Integer=0
	tem=first_node

	While tem
		jj=jj+1
		tem->id=jj
		tem=tem->next_node
	Wend
	Gurrent=ELE_from
END Function
'       
function List.Insert_S (ida As UInteger,valueS As String) As UInteger
	/'.....................................................................................................
	........................................    ........................................
	.....................................................................................................'/
	IF first_node   Then   '       
		Dim seek_node as ListNode Ptr '    
		seek_node = first_node '    
		do while seek_node '    ,     

			if seek_node->id = ida Then '    
				Exit Do
			end If
			seek_node = seek_node->next_node '    
		Loop
		DIM Predid AS ListNode Ptr
		Dim temp1 AS ListNode Ptr
		/'    ,      .
               '/
		If first_node=seek_node Then
			AddHeadS( valueS )
			Return 1
		ElseIf seek_node=0 Then
			AddLastS(valueS)
			Return 1
		EndIf

		Predid=seek_node->prev_node  '   
		Predid->next_node=NEW ListNode() '     
		Predid->next_node->valueS=valueS
		Predid->next_node->prev_node=Predid '    
		Predid->next_node->next_node=seek_node '   ""      
		seek_node->prev_node=Predid->next_node '   ""
		Gurrent=Predid->next_node
		Predid->id=Predid->id-1
		Predid->next_node->id=Predid->id+1
		temp1=Predid
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueS=valueS
		first_node->id=1
		last_node=first_node
		Gurrent=last_node
	END IF
END Function

function List.Insert_B (ida As UInteger,valueB As Byte) As UInteger

	/'.....................................................................................................
	........................................    ........................................
	.....................................................................................................'/
	IF first_node   Then   '       
		Dim seek_node as ListNode Ptr '    

		seek_node = first_node '    

		do while seek_node '    ,     

			if seek_node->id = ida Then '    
				Exit Do
			end If
			seek_node = seek_node->next_node '    
		loop

		DIM Predid AS ListNode Ptr
		Dim temp1 AS ListNode Ptr
		/'    ,      .
               '/

		If first_node=seek_node Then
			AddHeadB( valueB )
			Return 1
		ElseIf seek_node=0 Then
			AddLastB(valueB)
			Return 1	
		EndIf

		Predid=seek_node->prev_node  '   
		Predid->next_node=NEW ListNode() '     
		Predid->next_node->valueB=valueB
		Predid->next_node->prev_node=Predid '    
		Predid->next_node->next_node=seek_node '   ""      
		seek_node->prev_node=Predid->next_node '   ""
		Gurrent=Predid->next_node
		Predid->id=Predid->id-1
		Predid->next_node->id=Predid->id+1
		temp1=Predid
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueB=valueB
		first_node->id=1
		last_node=first_node
		Gurrent=last_node
	END IF
END Function

function List.Insert_SH (ida As UInteger,valueSh As Short) As UInteger

	/'.....................................................................................................
	........................................    ........................................
	.....................................................................................................'/
	IF first_node   Then   '       
		Dim seek_node as ListNode Ptr '    

		seek_node = first_node '    

		do while seek_node '    ,     

			if seek_node->id = ida Then '    
				Exit Do
			end If
			seek_node = seek_node->next_node '    
		loop

		DIM Predid AS ListNode Ptr
		Dim temp1 AS ListNode Ptr
		/'    ,      .
               '/

		If first_node=seek_node Then
			AddHeadSh( valueSh )
			Return 1
		ElseIf seek_node=0 Then
			AddLastSh(valueSh)
			Return 1
		EndIf

		Predid=seek_node->prev_node  '   
		Predid->next_node=NEW ListNode() '     
		Predid->next_node->valueSh=valueSh
		Predid->next_node->prev_node=Predid '    
		Predid->next_node->next_node=seek_node '   ""      
		seek_node->prev_node=Predid->next_node '   ""
		Gurrent=Predid->next_node
		Predid->id=Predid->id-1
		Predid->next_node->id=Predid->id+1
		temp1=Predid
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueSh=valueSh
		first_node->id=1
		last_node=first_node
		Gurrent=last_node
	END IF
END Function

function List.Insert_In (ida As UInteger,valueI As Integer) As UInteger

	/'.....................................................................................................
	........................................    ........................................
	.....................................................................................................'/
	IF first_node   Then   '       
		Dim seek_node as ListNode Ptr '    

		seek_node = first_node '    

		do while seek_node '    ,     

			if seek_node->id = ida Then '    
				Exit Do
			end If
			seek_node = seek_node->next_node '    
		loop

		DIM Predid AS ListNode Ptr
		Dim temp1 AS ListNode Ptr
		/'    ,      .
               '/

		If first_node=seek_node Then
			AddHeadIn( valueI )
			Return 1
		ElseIf seek_node=0 Then
			AddLastIn(valueI)
			Return 1
		EndIf

		Predid=seek_node->prev_node  '   
		Predid->next_node=NEW ListNode() '     
		Predid->next_node->valueI=valueI
		Predid->next_node->prev_node=Predid '    
		Predid->next_node->next_node=seek_node '   ""      
		seek_node->prev_node=Predid->next_node '   ""
		Gurrent=Predid->next_node
		Predid->id=Predid->id-1
		Predid->next_node->id=Predid->id+1
		temp1=Predid
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueI=valueI
		first_node->id=1
		last_node=first_node
		Gurrent=last_node
	END IF
END Function

function List.Insert_D (ida As UInteger,valueD As Double) As UInteger

	/'.....................................................................................................
	........................................    ........................................
	.....................................................................................................'/
	IF first_node   Then   '       
		Dim seek_node as ListNode Ptr '    

		seek_node = first_node '    

		do while seek_node '    ,     

			if seek_node->id = ida Then '    
				Exit Do
			end If
			seek_node = seek_node->next_node '    
		loop

		DIM Predid AS ListNode Ptr
		Dim temp1 AS ListNode Ptr
		/'    ,      .
               '/

		If first_node=seek_node Then
			AddHeadD( valueD )
			Return 1
		ElseIf seek_node=0 Then
			AddLastD(valueD)
			Return 1
		EndIf

		Predid=seek_node->prev_node  '   
		Predid->next_node=NEW ListNode() '     
		Predid->next_node->valueD=valueD
		Predid->next_node->prev_node=Predid '    
		Predid->next_node->next_node=seek_node '   ""      
		seek_node->prev_node=Predid->next_node '   ""
		Gurrent=Predid->next_node
		Predid->id=Predid->id-1
		Predid->next_node->id=Predid->id+1
		temp1=Predid
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueD=valueD
		first_node->id=1
		last_node=first_node
		Gurrent=last_node
	END IF
END Function

function List.Insert_L (ida As UInteger,valueL As LongInt) As UInteger

	/'.....................................................................................................
	........................................    ........................................
	.....................................................................................................'/
	IF first_node   Then   '       
		Dim seek_node as ListNode Ptr '    

		seek_node = first_node '    

		do while seek_node '    ,     

			if seek_node->id = ida Then '    
				Exit Do
			end If
			seek_node = seek_node->next_node '    
		loop

		DIM Predid AS ListNode Ptr
		Dim temp1 AS ListNode Ptr
		/'    ,      .
               '/

		If first_node=seek_node Then
			AddHeadL( valueL )
			Return 1
		ElseIf seek_node=0 Then
			AddLastL(valueL)
			Return 1
		EndIf

		Predid=seek_node->prev_node  '   
		Predid->next_node=NEW ListNode() '     
		Predid->next_node->valueL=valueL
		Predid->next_node->prev_node=Predid '    
		Predid->next_node->next_node=seek_node '   ""      
		seek_node->prev_node=Predid->next_node '   ""
		Gurrent=Predid->next_node
		Predid->id=Predid->id-1
		Predid->next_node->id=Predid->id+1
		temp1=Predid
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueL=valueL
		first_node->id=1
		last_node=first_node
		Gurrent=last_node
	END IF
END Function



'      
SUB List.AddHeadS (valueS As String)
	DIM temp2 AS ListNode Ptr
	DIM temp1 AS ListNode Ptr
	IF first_node   Then                                '       
		temp1=first_node  '   
		temp2 = first_node->next_node     '     
		first_node = NEW ListNode()  '  ,   
		first_node->valueS=valueS  '   
		first_node->next_node=temp1 '      
		first_node->next_node->prev_node=first_node
		first_node->next_node->next_node=temp2 '       
		first_node->id=0
		temp1=first_node
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueS=valueS
		first_node->id=1
		last_node=first_node
		Gurrent=last_node
	END IF
END Sub
SUB List.AddHeadL (valueL As LongInt)
	DIM temp2 AS ListNode Ptr
	DIM temp1 AS ListNode Ptr
	IF first_node   Then                                '       
		temp1=first_node  '   
		temp2 = first_node->next_node     '     
		first_node = NEW ListNode()  '  ,   
		first_node->valueL=valueL  '   
		first_node->next_node=temp1 '      
		first_node->next_node->prev_node=first_node
		first_node->next_node->next_node=temp2 '       
		first_node->id=0
		temp1=first_node
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueL=valueL
		first_node->id=1
		last_node=first_node
		Gurrent=last_node
	END IF
END Sub
SUB List.AddHeadD (valueD As Double)
	DIM temp2 AS ListNode Ptr
	DIM temp1 AS ListNode Ptr
	IF first_node   Then                                '       
		temp1=first_node  '   
		temp2 = first_node->next_node     '     
		first_node = NEW ListNode()  '  ,   
		first_node->valueD=valueD  '   
		first_node->next_node=temp1 '      
		first_node->next_node->prev_node=first_node
		first_node->next_node->next_node=temp2 '       
		first_node->id=0
		temp1=first_node
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueD=valueD
		first_node->id=1
		last_node=first_node
		Gurrent=last_node
	END IF
END Sub
SUB List.AddHeadIn (valueI As Integer)
	DIM temp2 AS ListNode Ptr
	DIM temp1 AS ListNode Ptr
	IF first_node   Then                                '       
		temp1=first_node  '   
		temp2 = first_node->next_node     '     
		first_node = NEW ListNode()  '  ,   
		first_node->valueI=valueI  '   
		first_node->next_node=temp1 '      
		first_node->next_node->prev_node=first_node
		first_node->next_node->next_node=temp2 '       
		first_node->id=0
		temp1=first_node
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueI=valueI
		last_node=first_node
		Last_node->id=1
		Gurrent=last_node
	END IF
END Sub
SUB List.AddHeadB (valueB As Byte)
	DIM temp2 AS ListNode Ptr
	DIM temp1 AS ListNode Ptr
	IF first_node   Then                                '       
		temp1=first_node  '   
		temp2 = first_node->next_node     '     
		first_node = NEW ListNode()  '  ,   
		first_node->valueB=valueB  '   
		first_node->next_node=temp1 '      
		first_node->next_node->prev_node=first_node
		first_node->next_node->next_node=temp2 '       
		first_node->id=0
		temp1=first_node
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueB=valueB
		last_node=first_node
		Last_node->id=1
		Gurrent=last_node
	END IF
END Sub
SUB List.AddHeadSH (valueSH As Short)
	DIM temp2 AS ListNode Ptr
	DIM temp1 AS ListNode Ptr
	IF first_node   Then                                '       
		temp1=first_node  '   
		temp2 = first_node->next_node     '     
		first_node = NEW ListNode()  '  ,   
		first_node->valueSh=valueSh  '   
		first_node->next_node=temp1 '      
		first_node->next_node->prev_node=first_node
		first_node->next_node->next_node=temp2 '       
		first_node->id=0
		temp1=first_node
		While temp1
			temp1->id=temp1->id+1
			temp1=temp1->next_node
		Wend
	ELSE                                      ' 
		first_node = NEW  ListNode()              '  
		first_node->valueSh=valueSh
		last_node=first_node
		Last_node->id=1
		Gurrent=last_node
	END IF
END Sub
'      
function List.AddLastS( valueS  as string ) as UInteger


	dim new_node as ListNode Ptr '    


	new_node = new ListNode() '   

	new_node->valueS = valueS '  

	if this.first_node = 0 then     '      ,     
		new_node->id = 1
		this.first_node = new_node
	else                                     '      ,     
		new_node->id = this.last_node->id + 1
		this.last_node->next_node = new_node
		new_node->prev_node = this.last_node
	end if


	this.last_node = new_node '    
	Gurrent=this.last_node

	return new_node->id '    

end Function

function List.AddLastB( valueB  as Byte ) as uinteger


	dim new_node as ListNode Ptr '    


	new_node = new ListNode() '   

	new_node->valueB = valueB '  

	if this.first_node = 0 then     '      ,     
		new_node->id = 1
		this.first_node = new_node
	else                                     '      ,     
		new_node->id = this.last_node->id + 1
		this.last_node->next_node = new_node
		new_node->prev_node = this.last_node
	end if


	this.last_node = new_node '    
	Gurrent=this.last_node

	return new_node->id '    

end Function
function List.AddLastSH( valueSH  as short ) as uinteger


	dim new_node as ListNode Ptr '    


	new_node = new ListNode() '   

	new_node->valueSH = valueSH '  

	if this.first_node = 0 then     '      ,     
		new_node->id = 1
		this.first_node = new_node
	else                                     '      ,     
		new_node->id = this.last_node->id + 1
		this.last_node->next_node = new_node
		new_node->prev_node = this.last_node
	end if


	this.last_node = new_node '    
	Gurrent=this.last_node

	return new_node->id '    

end Function

'      
function List.AddLastL( valueL  as LongInt) as uinteger


	dim new_node as ListNode Ptr '    


	new_node = new ListNode() '   


	new_node->valueL = valueL '  

	if this.first_node = 0 then     '      ,     
		new_node->id = 1
		this.first_node = new_node
	else                                     '      ,     
		new_node->id = this.last_node->id + 1
		this.last_node->next_node = new_node
		new_node->prev_node = this.last_node
	end if


	this.last_node = new_node '    
	Gurrent=this.last_node

	return new_node->id '    

end Function

'      
function List.AddLastIn( valueI  as Integer ) as uinteger


	dim new_node as ListNode Ptr '    


	new_node = new ListNode() '   


	new_node->valueI = valueI '  

	if this.first_node = 0 then     '      ,     
		new_node->id = 1
		this.first_node = new_node
	else                                     '      ,     
		new_node->id = this.last_node->id + 1
		this.last_node->next_node = new_node
		new_node->prev_node = this.last_node
	end if


	this.last_node = new_node '    

	Gurrent=this.last_node
	return new_node->id '    

end Function
'      
function List.AddLastD( valueD  as Double ) as uinteger


	dim new_node as ListNode Ptr '    


	new_node = new ListNode() '   


	new_node->valueD = valueD '  

	if this.first_node = 0 then     '      ,     
		new_node->id = 1
		this.first_node = new_node
	else                                     '      ,     
		new_node->id = this.last_node->id + 1
		this.last_node->next_node = new_node
		new_node->prev_node = this.last_node
	end if


	this.last_node = new_node '    

	Gurrent=this.last_node
	return new_node->id '    

end Function

'    
sub List.Remove( ida as uinteger )
	If ida <>1 Then
		Gurrent=this.FindByID( ida-1 )
	Else
		Gurrent=this.FindByID( ida+1  )
	EndIf
	dim del_node as ListNode Ptr '    
	del_node = this.FindByID( ida ) '   

	if del_node = 0 Then ' ,    
		exit sub
	end If

	if this.first_node = del_node Then '    
		this.first_node = del_node->next_node
	Else
		del_node->prev_node->next_node = del_node->next_node
	end if

	if this.last_node = del_node Then '    
		this.last_node = del_node->prev_node
	Else
		del_node->next_node->prev_node = del_node->prev_node
	end if

	delete del_node '   
	Dim tem As ListNode Ptr
	Dim jj As Integer=0
	tem=first_node

	While tem
		jj=jj+1
		tem->id=jj
		tem=tem->next_node
	Wend
end Sub
function List.PRED( ) as ListNode Ptr

	Gurrent=Gurrent->prev_node
	Return Gurrent
End Function

function List.First( ) as ListNode Ptr

	Gurrent=first_node
	Return Gurrent
End Function

function List.Last( ) as ListNode Ptr

	Gurrent=last_node
	Return Gurrent
End Function

function List.GURR( ) as ListNode Ptr

	Gurrent=Gurrent->next_node
	Return Gurrent
End Function
function List.GURR1( ) as ListNode Ptr
	Return Gurrent
End Function

'    
function List.FindByID( id as uinteger ) as ListNode ptr

	dim seek_node as ListNode Ptr '    

	seek_node = this.first_node '    

	do while seek_node '    ,     

		if seek_node->id = id Then '    
			Gurrent=seek_node
			return seek_node
		end if


		seek_node = seek_node->next_node '    
	loop

	return 0 '  0,    

end Function


FUNCTION List.GetCount (lis As List Ptr) As Integer
	Var ggg=SelectElement(lis,1)
	If ggg=0 Then
		ggg=SelectElement(lis,2)
		If ggg=0 Then Return 0
	EndIf
	DIM temp  AS ListNode PTR = ggg'         
	DIM count AS INTEGER    = 0  '   
	WHILE temp                          '    
		count = count + 1              '  
		temp = temp->next_node          '   
	WEND
	RETURN count
END Function

' ---------------------------------------------   --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Sub MoveElement(ByVal lis As List Ptr,ByVal from_ As UInteger, byval in_ As UInteger) Export
	lis->Move(in_, from_ )
End Sub
' ---------------------------------------------   --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Sub InsertElement_S(ByVal lis As List Ptr,ByVal item As UInteger, byval  znach As String) Export
	lis->Insert_S(item, znach )
End Sub
Sub InsertElement_SH(ByVal lis As List Ptr,ByVal item As UInteger, byval  znach As Short) Export
	lis->Insert_SH(item, znach )
End Sub
Sub InsertElement_B(ByVal lis As List Ptr,ByVal item As UInteger, byval  znach As Byte) Export
	lis->Insert_B(item, znach )
End Sub
Sub InsertElement_D(ByVal lis As List Ptr,ByVal item As UInteger, byval  znach As Double)Export
	lis->Insert_D(item, znach )
End Sub
Sub InsertElement_L(ByVal lis As List Ptr,ByVal item As UInteger, byval  znach As LongInt)Export
	lis->Insert_L(item, znach )
End Sub
Sub InsertElement_In(ByVal lis As List Ptr,ByVal item As UInteger, byval  znach As Integer)Export
	lis->Insert_In(item, znach )
End Sub
' ---------------------------------------   --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Sub AddElementHead_SH(ByVal lis As List Ptr,ByVal  znach As Short)Export
	lis->AddHeadSH( znach )
End Sub
Sub AddElementHead_B(ByVal lis As List Ptr,ByVal  znach As Byte)Export
	lis->AddHeadB( znach )
End Sub
Sub AddElementHead_S(ByVal lis As List Ptr,ByVal  znach As String)Export
	lis->AddHeadS( znach )
End Sub
Sub AddElementHead_L(ByVal lis As List Ptr,ByVal  znach As LongInt)Export
	lis->AddHeadL( znach )
End Sub
Sub AddElementHead_D(ByVal lis As List Ptr,ByVal  znach As Double)Export
	lis->AddHeadD( znach )
End Sub
Sub AddElementHead_In(ByVal lis As List Ptr,ByVal  znach As Integer)Export
	lis->AddHeadIn( znach )
End Sub
' --------------------------------------   --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Sub AddElement_S(ByVal lis As List Ptr,ByVal  znach As String)Export
	lis->AddLastS( znach )
End Sub
Sub AddElement_L(ByVal lis As List Ptr,ByVal  znach As LongInt)Export
	lis->AddLastL( znach )
End Sub
Sub AddElement_In(ByVal lis As List Ptr,ByVal  znach As integer)Export
	lis->AddLastIn( znach )
End Sub
Sub AddElement_D(ByVal lis As List Ptr,ByVal  znach As Double)Export
	lis->AddLastD( znach )
End Sub
Sub AddElement_B(ByVal lis As List Ptr,ByVal  znach As Byte)Export
	lis->AddLastB( znach )
End Sub
Sub AddElement_Sh(ByVal lis As List Ptr,ByVal  znach As Short)Export
	lis->AddLastSH( znach )
End Sub
'--------------------------------------  --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Function NewList() As List Ptr Export
	Return New List()
End Function
' -------------------------------------- --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Sub DeleteList(ByVal lis As List Ptr )Export
	Delete Lis
End Sub
' -------------------------------------- --------------------------------------------
'---------------------------------------------------------------------------------------------------------------

Sub ClearList(ByVal lis As List Ptr )Export
	lis->Clear
End Sub
' -------------------------------------- --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Function SizeList(ByVal lis As List Ptr ) As Integer Export
	DIM alls AS List
	Return alls.GetCount(lis)
End Function
'-------------------------------------- --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
sub DeleteElement(ByVal lis As List Ptr,ByVal  element As integer)Export
	lis->Remove( element )
End Sub
'--------------------------------------    --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Function SelectElement(ByVal lis As List Ptr,ByVal  element As integer) as ListNode Ptr Export
	Return lis->FindByID( element)
End Function
' --------------------------------------   --------------------------------------------
'---------------------------------------------------------------------------------------------------------------

Function PrevElement(ByVal lis As List Ptr ) As Integer Export
	Return Cast(Integer,lis-> PRED( ))
End Function
' --------------------------------------   --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Function NextElement(ByVal lis As List Ptr ) As Integer Export
	Return Cast(Integer,lis-> GURR( ))
End Function
' --------------------------------------    --------------------------------------------
'---------------------------------------------------------------------------------------------------------------

Function FirstElement(ByVal lis As List Ptr ) As Integer Export
	Return Cast(Integer,lis-> First( ))
End Function
' --------------------------------------    --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Function LastElement(ByVal lis As List Ptr ) As Integer Export
	Return Cast(Integer,lis-> Last( ))
End Function
'--------------------------------------    --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Function GetValueElement_S(ByVal lis As List Ptr,ByVal  element As integer) as String Export
	Return lis->FindByID( element)->VALUES
End Function
Function GetValueElement_In(ByVal lis As List Ptr,ByVal  element As integer) as Integer Export
	Return lis->FindByID( element)->VALUEI
End Function
Function GetValueElement_L(ByVal lis As List Ptr,ByVal  element As integer) as LongInt Export
	Return lis->FindByID( element)->VALUEL
End Function
Function GetValueElement_D(ByVal lis As List Ptr,ByVal  element As integer) As Double Export
	Return lis->FindByID( element)->VALUED
End Function
Function GetValueElement_B(ByVal lis As List Ptr,ByVal  element As integer) as Byte Export
	Return lis->FindByID( element)->VALUEB
End Function
Function GetValueElement_SH(ByVal lis As List Ptr,ByVal  element As integer) As Short Export
	Return lis->FindByID( element)->VALUESH
End Function
' --------------------------------------    --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Sub SetValueElement_D(ByVal lis As List Ptr ,ByVal element As Integer,ByVal znachenie As Double )Export
	Lis->FindByID(element)->VALUED=znachenie
End Sub
Sub SetValueElement_S(ByVal lis As List Ptr ,ByVal element As Integer,ByVal znachenie As String)Export
	Lis->FindByID(element)->VALUES=znachenie
End Sub
Sub SetValueElement_L(ByVal lis As List Ptr ,ByVal element As Integer,ByVal znachenie As LongInt)Export
	Lis->FindByID(element)->VALUEL=znachenie
End Sub
Sub SetValueElement_In(ByVal lis As List Ptr ,ByVal element As Integer,ByVal znachenie As Integer )Export
	Lis->FindByID(element)->VALUEI=znachenie
End Sub
Sub SetValueElement_B(ByVal lis As List Ptr ,ByVal element As Integer,ByVal znachenie As Byte)Export
	Lis->FindByID(element)->VALUEB=znachenie
End Sub
Sub SetValueElement_SH(ByVal lis As List Ptr ,ByVal element As Integer,ByVal znachenie As Short )Export
	Lis->FindByID(element)->VALUESH=znachenie
End Sub
' --------------------------------------    --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Function GetList_S(ByVal lis As List Ptr  ) As string Export
	Return lis-> GURR1( )->VALUES
End Function
Function GetList_In(ByVal lis As List Ptr  ) As integer Export
	Return lis-> GURR1( )->VALUEI
End Function
Function GetList_L(ByVal lis As List Ptr  ) As longint Export
	Return lis-> GURR1( )->VALUEL
End Function
Function GetList_D(ByVal lis As List Ptr  ) As Double Export
	Return lis-> GURR1( )->VALUED
End Function
Function GetList_B(ByVal lis As List Ptr  ) As Byte Export
	Return lis-> GURR1( )->VALUEB
End Function
Function GetList_SH(ByVal lis As List Ptr  ) As Short Export
	Return lis-> GURR1( )->VALUESH
End Function
' --------------------------------------    --------------------------------------------
'---------------------------------------------------------------------------------------------------------------
Sub SetList_S(ByVal lis As List Ptr, ByVal znachenie As String )Export
	lis-> GURR1( )->VALUES=znachenie
End Sub
Sub SetList_D(ByVal lis As List Ptr, ByVal znachenie As Double )Export
	lis-> GURR1( )->VALUED=znachenie
End Sub
Sub SetList_L(ByVal lis As List Ptr, ByVal znachenie As LongInt )Export
	lis-> GURR1( )->VALUEL=znachenie
End Sub
Sub SetList_In(ByVal lis As List Ptr, ByVal znachenie As Integer )Export
	lis-> GURR1( )->VALUEI=znachenie
End Sub
Sub SetList_B(ByVal lis As List Ptr, ByVal znachenie As Byte )Export
	lis-> GURR1( )->VALUEB=znachenie
End Sub
Sub SetList_SH(ByVal lis As List Ptr, ByVal znachenie As Short )Export
	lis-> GURR1( )->VALUESH=znachenie
End Sub


